<template>
  <VApp>
    <!-- painel A -->
    <VueResizable
      style="position: fixed;"
      :active="['r']"
      :min-width="190"
      :width="tW"
      @mount="eHandler"
      @resize:move="eHandler"
      @resize:start="eHandler"
      @resize:end="eHandler"
      @drag:move="eHandler"
      @drag:start="eHandler"
      @drag:end="eHandler"
    >
      <VNavigationDrawer app permanent :width="tW">
        <template v-slot:prepend>
          <VRow
            :class="['pa-3', miniAPanel && 'text-center']"
            align="center"
            no-gutters
          >
            <VCol :cols="miniAPanel ? 12 : 6" :class="[miniAPanel && 'pb-3']">
              <VBadge
                bordered
                bottom
                color="success"
                dot
                offset-x="10"
                offset-y="10"
              >
                <VMenu offset-y>
                  <template v-slot:activator="{ on, attrs }">
                    <VAvatar color="red" v-bind="attrs" v-on="on">
                      <img
                        v-if="!!profile.photoUrl"
                        :src="profile.photoUrl"
                        :alt="profile.name"
                      />
                      <span v-else class="white--text headline">{{
                        getFirstLetter(profile.name)
                      }}</span>
                    </VAvatar>
                  </template>
                  <VList>
                    <VListItem @click="changeLogout()">
                      <VListItemAction>
                        <VIcon style="transform: rotateY(-180deg);"
                          >mdi-export</VIcon
                        >
                      </VListItemAction>
                      <VListItemContent>
                        <VListItemTitle>Logout</VListItemTitle>
                      </VListItemContent>
                    </VListItem>
                  </VList>
                </VMenu>
              </VBadge>
            </VCol>
            <VCol
              :cols="miniAPanel ? 12 : 6"
              :class="{ 'text-right': !miniAPanel }"
            >
              <VMenu offset-y>
                <template v-slot:activator="{ on, attrs, value }">
                  <VBtn color="primary" dark depressed v-bind="attrs" v-on="on">
                    Novo
                    <VIcon :class="{ 'rotate-animate': value }" right
                      >mdi-menu-down</VIcon
                    >
                  </VBtn>
                </template>
                <VList>
                  <VListItem v-for="item in 3" :key="item" link>
                    <VListItemTitle>Opção {{ item }}</VListItemTitle>
                  </VListItem>
                </VList>
              </VMenu>
            </VCol>
          </VRow>

          <VDivider class="mx-3" />
        </template>

        <!-- main -->
        <p class="d-flex align-center mx-3 px-4 mt-3 text-subtitle-2">
          Favoritas <VIcon>mdi-dots-vertical</VIcon>
          <span class="ml-auto">30</span>
        </p>
        <VTreeview
          class="mx-3 text-subtitle-2"
          :items="panelAItems"
          item-children="subMenus"
          hoverable
          open-on-click
          activatable
          @update:active="itemEmail = $event[0]"
        >
          <template v-slot:append="{ item }">
            {{ item.name === 'Conta 3' ? 20 : 15 }}
          </template>
        </VTreeview>

        <template v-slot:append>
          <VList shaped>
            <VListItem @click="toggleDark">
              <VListItemAction>
                <VIcon
                  >mdi-{{
                    dark ? 'weather-night' : 'white-balance-sunny'
                  }}</VIcon
                >
              </VListItemAction>
              <VListItemContent>
                <VListItemTitle
                  >Tema {{ dark ? 'Escuro' : 'Claro' }}</VListItemTitle
                >
              </VListItemContent>
            </VListItem>
          </VList>
        </template>
      </VNavigationDrawer>
    </VueResizable>

    <!-- main -->
    <VMain>
      <Nuxt />
    </VMain>

    <!-- popup: msg -->
    <FloatMsg />
  </VApp>
</template>

<script lang="ts">
import {
  Component,
  Watch,
  mixins,
  namespace,
  State,
  Mutation,
} from 'nuxt-property-decorator'
import { ChangeLogout, GetFirstLetter, OnMsg } from '@/mixins'
import { errorServer } from '@/data/msg.json'

import { RootState } from '@/store/account'
const accountModule = namespace('account')
const VueResizable = require('vue-resizable').default

@Component({
  middleware: 'authenticate',

  components: {
    VueResizable,
    FloatMsg: () => import('@/components/layouts/FloatMsg.vue'),
  },
})
export default class Default extends mixins(
  ChangeLogout,
  GetFirstLetter,
  OnMsg
) {
  @State
  dark!: boolean

  @accountModule.State
  profile!: RootState['profile']

  @accountModule.State
  user!: RootState['user']

  @Mutation
  toggleDark!: () => void

  @Mutation
  setDark!: (bool: boolean) => void

  @accountModule.Action
  checkUserExist!: () => Promise<void>

  @accountModule.Action
  tokenRefresh!: () => void

  get miniAPanel() {
    return this.tW < 227
  }

  interval: NodeJS.Timeout | null = null
  tW = 256
  panelAItems = []

  get itemEmail() {
    return this.user.itemEmail!
  }

  set itemEmail(val: number | undefined) {
    const itemEmail = typeof val === 'undefined' ? null : val
    this.$store.commit('account/setUser', { itemEmail })
  }

  async created() {
    try {
      this.panelAItems = await this.$axios.$get('menus')
    } catch (err) {
      console.error(err)
      this.onMsg(errorServer, 'error', { timeout: 0 })
    }
  }

  mounted() {
    this.tokenRefresh()
    // refresh in 50min
    this.interval = setInterval(() => this.tokenRefresh(), 50 * 60 * 1000)

    const dark = localStorage.getItem('dark')
    if (dark !== null) {
      this.setDark(dark === 'true')
    } else {
      this.setDark(this.dark)
    }
  }

  destroyed() {
    if (this.interval != null) {
      clearInterval(this.interval)
    }
  }

  eHandler(data: any) {
    this.tW = data.width
  }

  @Watch('dark')
  onChangeDark(bool: boolean) {
    this.$vuetify.theme.dark = bool
    localStorage.setItem('dark', String(bool))
  }
}
</script>
